(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     23014,        782]*)
(*NotebookOutlinePosition[     53090,       1882]*)
(*  CellTagsIndexPosition[     53046,       1878]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["MathCodeF90  Release Notes", "Title"],

Cell["Version 1.2", "Subtitle"],

Cell["22 march 2013", "Subsubtitle"],

Cell[TextData[{
  "\nPlease read installations instructions before the installation. They \
explain which Fortran90 compilers are compatible with MathCode F90 and how \
they should be installed. Additional information can be found in MathCode FAQ \
at ",
  StyleBox["www.mathcore.com",
    FontWeight->"Bold"],
  ". \nThese Release Notes include important last-minute information and \
platform-specific details which has not been included into the MathCode F90 \
manual."
}], "Text"],

Cell[CellGroupData[{

Cell["Changes in MathCode F90 1.2", "Section"],

Cell["Mathcode F90 1.2 is a port release:", "Text"],

Cell[TextData[StyleBox["Can handle String rtpe in function parameters. \
Supports external functions in Fortran90.", "Itemize"]], "Itemize"],

Cell[TextData[{
  StyleBox["Compatible with ", "Itemize"],
  StyleBox["Mathematica", "Itemize",
    FontSlant->"Italic"],
  StyleBox[" 8.0 and 9.0 .  Also, compatible with  6.0, 7.0", "Itemize"]
}], "Itemize"],

Cell[TextData[{
  StyleBox["Contains support for a free Fortan90 compilers ", "Itemize"],
  StyleBox["\"", "Itemize",
    FontWeight->"Bold"],
  StyleBox["g95", "Itemize",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox["\"", "Itemize",
    FontWeight->"Bold"],
  StyleBox[" and ", "Itemize"],
  StyleBox["\"gfortran\"", "Itemize",
    FontWeight->"Bold"],
  StyleBox[", as well as Intel Fortran (", "Itemize"],
  StyleBox["\"ifort\"", "Itemize",
    FontWeight->"Bold"],
  StyleBox[") on Linux.  Installation instructions contains necessary \
information for other Fortran 90 compilers.", "Itemize"]
}], "Itemize"],

Cell[TextData[StyleBox["Available on Windows, Linux and MacOSX.", \
"Itemize"]], "Itemize"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Changes in MathCode F90 1.0.1", "Section"],

Cell["\<\
Mathcode F90 1.0.1 is a bug-fix release where several bugs were fixed, such \
as\
\>", "Text"],

Cell[TextData[StyleBox["Comparison of arrays", "Itemize"]], "Itemize"],

Cell[TextData[StyleBox["Matrix  operations (Outer, Cross, Transpose)", \
"Itemize"]], "Itemize"],

Cell[TextData[StyleBox["Which statement  ", "Itemize"]], "Itemize"],

Cell[TextData[StyleBox["Map and Apply", "Itemize"]], "Itemize"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Mathematica ",
    FontSlant->"Italic"],
  "and licensing  details"
}], "Section"],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " compatibility and XML package"
}], "Subsection"],

Cell[TextData[{
  "MathCode F90 1.0.1 is compatible with Mathematica \nIf you use XML package \
in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 5.0 or 5.1 and MathCode F90 then symbol ",
  StyleBox["Declare",
    FontWeight->"Bold"],
  " causes a name conflict. Do not load MathCode and XML simultaneously. When \
MathCode starts it explicitly un-defines the symbol ",
  StyleBox["Declare",
    FontWeight->"Bold"],
  "."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["About license key installation", "Subsection"],

Cell[TextData[{
  "License information is distributed by MathCore in the form of key files, \
containing encoded license data. To create a key file, MathCore needs the \
MathID (the value of the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " variable ",
  StyleBox["$MachineID", "InlineInput"],
  ") for the machine the license is intended for. The normal procedure is to \
distribute key files as e-mail attachments. You can use this key during \
MathCode installation.\nIf you already installed MathCode and you want to add \
 a new license, simply save the attached file to the ",
  StyleBox["Licensing",
    FontFamily->"Courier"],
  " subdirectory of your MathCode installation. Any number of key files can \
be put in this directory; MathCode automatically updates an index file (",
  StyleBox["index.m",
    FontFamily->"Courier"],
  ") keeping track of machine identities and key files. On a site/network \
installation, this file and the ",
  StyleBox["Licensing",
    FontFamily->"Courier"],
  " subdirectory needs to be  writable for all  users which are allowed to \
install license files."
}], "Text"],

Cell["\<\
You also have the opportunity to select a key file during the installation \
process. Obtaining a key file for your machine before installing MathCode \
thus makes the process a bit smoother.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["MathCode Compiler messages", "Subsection"],

Cell[TextData[{
  "Messages from the compiler are often pretty long and get shortened by ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " using ",
  StyleBox["Short[]", "InlineInput"],
  ". This shortening can be prevented by doing this:"
}], "Text"],

Cell[BoxData[
    \(\($MessagePrePrint = Identity;\)\)], "Input"],

Cell[TextData[{
  "This will make ",
  StyleBox["Message[]", "InlineInput"],
  " always print the full text of messages."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Fortran90 details ", "Section"],

Cell[CellGroupData[{

Cell["Fortran90 code generation", "Subsection"],

Cell[TextData[{
  "By default Fortran90 code is generated. It is not necessary to use the \
command ",
  Cell[BoxData[
      \(\(\(\ \ \)\(SetCompilationOptions[
          Language \[Rule] "\<Fortran90\>"];\)\)\)], "Input"],
  " in order to activate Fortran90 code generation."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Choice of Fortran compiler", "Subsection"],

Cell[TextData[{
  "There is  a file ",
  StyleBox["MathCodeConfig.m",
    FontFamily->"Courier"],
  " in the main MathCode directory. This file is really a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " package that contains some configuration directives; currently ",
  StyleBox["DefineCompiler[] ", "InlineInput"],
  "and ",
  StyleBox["DefaultCompiler[]", "InlineInput"],
  "."
}], "Text"],

Cell[TextData[{
  StyleBox["DefineCompiler[]", "InlineInput"],
  " is used to associate a symbolic compiler name (a string) with a make \
file, a command template, and a build command.  You don't normally need to \
bother with these details."
}], "Text"],

Cell[TextData[{
  StyleBox["DefaultCompiler[]", "InlineInput"],
  " is used to select the default compiler definition for a language. The \
only language supported by MathCodeF90 for code generation is Fortran90. In \
",
  StyleBox["MathCodeConfig.m",
    FontFamily->"Courier"],
  " you will find a line"
}], "Text"],

Cell[BoxData[
    \(\(DefaultCompiler["\<Fortran90\>" -> "\<ifort80\>"];\)\)], "Input"],

Cell["\<\
This tells MathCode to use the included \"ifort80\" compiler definition \
(Intel Fortran 8.0) when generating Fortran90 code. 
If you wish to use Digital Fortran 6.0 instead, you should change this to \
read:\
\>", "Text"],

Cell[BoxData[
    \(\(DefaultCompiler["\<Fortran90\>" -> "\<df60\>"];\)\)], "Input"],

Cell[TextData[{
  "After you change the default compiler to ",
  StyleBox["df60",
    FontWeight->"Bold"],
  " you should run the script ",
  StyleBox[" (",
    FontWeight->"Bold"],
  StyleBox["MathCode",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[")\\lib\\stdpackages\\src\\use_df60.bat",
    FontWeight->"Bold"],
  "\nIf you decide to change the default compiler to",
  StyleBox[" ifort80 ",
    FontWeight->"Bold"],
  "you should run the script ",
  StyleBox[" (",
    FontWeight->"Bold"],
  StyleBox["MathCode",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[")\\lib\\stdpackages\\src\\use_ifort80.bat",
    FontWeight->"Bold"]
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

Configuring environment variables for Fortran compiler.\
\>", "Subsection"],

Cell["\<\
Fortran should  be configured for \"command line compilation\" for MathCode \
to be able to call it. Normally at the end of Fortran compiler installation \
you will be presented with a dialog \"Setup Environment Variables\". Check \
the box \"Register Environment Variables\" and finish the installation.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "Starting ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " using a BAT file."
}], "Subsection"],

Cell[TextData[{
  "If for some reason you do not configure your Fortran complier this way, \
you have to modify the way you start ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". Create a BAT file with two lines: In the first line you call the BAT \
file which sets environment variables of your Fortran compiler (e.g. ",
  StyleBox["dfvars.bat",
    FontWeight->"Bold"],
  " or",
  StyleBox[" ifortvars.bat",
    FontWeight->"Bold"],
  "). In the second line you start ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ".exe."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Compilable subset implementation information and caveats", "Section"],

Cell[CellGroupData[{

Cell["Variable names", "Subsection"],

Cell[TextData[{
  StyleBox["dim", "InlineInput"],
  " is not an allowed variable name in MathCode, as this creates conflicts \
with internal MathCode identifiers."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Increments, Decrement, PreIncrement, PreDecrement", "Subsection"],

Cell[TextData[{
  "The occurrences of i++, ++i, i--, and --i are translated to set statements \
as i=i+1, and i=i-1. Note that this transformation is only valid when \
Increments, Decrement, PreIncrement, and PreDecrement are used as statements \
since the behavior of return values from this operations are not preserved as \
in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "."
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Strings", "Subsection"],

Cell["\<\
Only 7-bit ascii characters are supported in strings. This implies that \
international characters  cannot be converted.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["If - expressions", "Subsection"],

Cell[TextData[{
  "If-expressions cannot be used directly within other expressions in \
MathCode F90. For instance, function call ",
  StyleBox["Foo[If[a==1, b, c]]",
    FontWeight->"Bold"],
  " cannot be compiled. If-statements can be used ( ",
  StyleBox["If [a==1, c=2, d=4]",
    FontWeight->"Bold"],
  ") in the sequence of other statements. \nAs a special case, ",
  StyleBox["Set[..,If[]]",
    FontWeight->"Bold"],
  " is allowed: ",
  StyleBox[" x = If [a==1, b, c]",
    FontWeight->"Bold"]
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Which - expressions", "Subsection"],

Cell[TextData[{
  "Which-expressions cannot be used directly within other expressions in \
MathCode F90. For instance, function call ",
  StyleBox["Foo[ Which [a==1, b, a==2, c ]]",
    FontWeight->"Bold"],
  " cannot be compiled.Which-statements can be used (",
  StyleBox["Which",
    FontWeight->"Bold"],
  StyleBox["[a==1, c=2, a==2, d=4]",
    FontWeight->"Bold"],
  ") in the sequence of other statements. "
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CompoundExpressions within expressions", "Subsection"],

Cell[TextData[{
  "Compound-expressions (i.e. a sequence of statements)  can be used directly \
within other expressions. In this case all these statements are executed \
before the expression evaluation starts. For instance ",
  StyleBox["x=a+(b=a;b+1)",
    FontWeight->"Bold"],
  " is translated to\n",
  StyleBox[" b=a\n x=a+b+1",
    FontWeight->"Bold"]
}], "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Blocks", "Subsection"],

Cell[TextData[StyleBox[
"The blocks Module, With, and Block can be nested and variables can be \
declared at different levels and with different scope. However, declarations \
of local variables in a nested block must be independent of prior execution \
of code in the block enclosing the block. For example"]], "Text"],

Cell[BoxData[
    \(Module[{x\  = \ a, \ y = c}, \n\t\tx\  = 3; \n\t\ Module[{y = d}, \ 
        x = y]\n]\)], "Input"],

Cell["is converted to", "Text"],

Cell[BoxData[
    \(Module[
      {x\  = \ a, \ y = c, \ y$xx\  = \ d}, \n\t\tx\  = \ 3; \n\t\tx\  = \ 
        y$$xx\n\t]\)], "Input"],

Cell[TextData[StyleBox["This will work fine, but for the following"]], "Text"],

Cell[BoxData[
    \(Module[{x\  = \ a, \ y = c}, \n\t\tx\  = 3; \n\td\  = \ x; \n\t\ 
      Module[{y = d}, \ x = y]\n]\)], "Input"],

Cell["the conversion will fail since the resulting code is then", "Text"],

Cell[BoxData[
    \(Module[
      {x\  = \ a, \ y = c, \ y$xx\  = \ d}, \n\t\tx\  = \ 3; \n\t\td\  = \ 
        x; \n\t\tx\  = \ y$$xx\n\t]\)], "Input"],

Cell[TextData[StyleBox[
"Note! The same rule is true for variable used as dimension specifiers for \
declarations of local arrays, e.g."]], "Text"],

Cell[BoxData[
    \(Module[{x\  = \ a, \ n = c}, \n\t\tn\  = 3; \n\t\ 
      Module[{Integer[n]@\ y = d}, \ x = y]\n]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Round", "Subsection"],

Cell[TextData[{
  "Converting reals to integers can be done by using Round. Round will be \
converted to the standard Fortran90 function ",
  StyleBox["anint",
    FontWeight->"Bold"],
  ". Unfortunately this is not always the same conversion as Mathematica \
Round for half way numbers, where Round is converting to the nearest even \
number. How the conversion is done is dependent on the Fortran90-compiler \
used."
}], "Text"],

Cell[TextData[StyleBox[
"The following function can be used to test the floating point conversion."]],
   "Text"],

Cell[BoxData[
    \(\(irinttest[Real\ x_]\  -> \ Integer\  := \ Round[x];\)\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ArcTan", "Subsection"],

Cell["\<\
The two input argument version of ArcTan[x_,y_] is not supported for matrix \
input arguments.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Iterators, Do, Table, Sum, Product, Array", "Subsection"],

Cell[CellGroupData[{

Cell["Zero Step Size", "Subsubsection"],

Cell["Using a zero step size in an iterator specification like", "Text"],

Cell[BoxData[
    \(Table[i, {i, start, stop, 0}]\)], "Input"],

Cell[TextData[{
  "will in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " generate an error."
}], "Text"],

Cell["\<\
For the generated code this will give an infinite loop, since this case is \
not checked for at runtime.\
\>", "Text"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Table", "Subsubsection"],

Cell[TextData[StyleBox[
"The code generation for Table is only possible when the Table is placed \
directly to an assignment of a declared variable, like"]], "Text"],

Cell[BoxData[
    \(var\  = \ Table[i, {i, 1, 3}]\)], "Input"],

Cell[TextData[{
  StyleBox[
  "This makes it possible to translate as a loop that assigns each element of \
the variable. For the case above the corresponding "],
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  StyleBox[" code is"]
}], "Text"],

Cell[BoxData[{
    \(\(setshape[var, 3];\)\), "\n", 
    \(Do[\n\t\tvar[\([i]\)]\  = \ i, \ {i, 1, 3}\n]\)}], "Input"],

Cell[TextData[{
  "The function ",
  StyleBox["setshape",
    FontFamily->"Courier"],
  " is an internal MathCode function that sets the size or dimensions of the \
data structure corresponding to ",
  StyleBox["var",
    FontFamily->"Courier"],
  " before the loop is executed. "
}], "Text"],

Cell[TextData[StyleBox["Remark"]], "Text",
  FontWeight->"Bold"],

Cell[TextData[{
  StyleBox["Using iterators that is not iterated at all will in "],
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  StyleBox[
  " produce empty lists at some specific level. If the resulting table has 2 \
or more levels and one or more of its dimensions are zero, this will not be \
treated properly by "],
  StyleBox["MathLink",
    FontSlant->"Italic"],
  StyleBox[". "]
}], "Text"],

Cell["By externally executing the following:", "Text"],

Cell[BoxData[
    \(Table[i, {3}, {i, 1, 3, \(-1\)}]\)], "Input"],

Cell["will return", "Text"],

Cell[BoxData[
    \($Aborted\)], "Input"],

Cell[TextData[{
  "by ",
  StyleBox["MathLink.",
    FontSlant->"Italic"],
  " See section \"Zero Dimensions and ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  "\"."
}], "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["MathLink", "Subsection"],

Cell[CellGroupData[{

Cell["Zero Dimensions and MathLink", "Subsubsection"],

Cell["\<\
When using list and tensor constructors like Table and Array it is possible \
to produce tensors with one or more zero dimensions.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(zten\  = \ Table[i + j, {i, 1, 3}, {j, 1, 3, \(-1\)}]\)], "Input"],

Cell[BoxData[
    \({{}, {}, {}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Dimensions[zten]\)], "Input"],

Cell[BoxData[
    \({3, 0}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "For the moment variables from Table and Array are declared as real or \
integer lists, matrices, or tensors where the maximum number of dimensions \
supported by MathCode is 4. Tensors with dimensions from 2 - 4 are pasted \
through ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " using the functions ",
  StyleBox["MLPutIntegerArray",
    FontFamily->"Courier"],
  " and ",
  StyleBox["MLPutRealArray",
    FontFamily->"Courier"],
  ". These function cannot handle zero dimensions which implies that if a \
zero dimension tensor is sent, the symbol ",
  StyleBox["$Aborted",
    FontFamily->"Courier"],
  " will appear as output in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ".  "
}], "Text"],

Cell[TextData[{
  "For one dimensional lists the ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  " functions MLPutRealList and MLPutIntegerList are used instead which can \
handle lists of zero length. Therefore Table and Array constructors returning \
one dimensional empty lists will work correctly."
}], "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Coding recommendations", "Section"],

Cell[TextData[{
  "The interactive environment in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " supports very flexible and powerful ways to develop, test, and with \
MathCode produce executable code. However, it is a good rule to take some \
precaution of how to evaluate and redefine the declarations and functions \
that are intended for the code generation."
}], "Text"],

Cell[TextData[{
  "The normal rules of how to define and evaluate ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " packages should be used. Encapsulate the code into BeginPackage and \
EndPackage. Let all \"exported\" symbol be created outside the private \
section (marked by Begin[\"`Private`\"] and End[]), and let the function \
definitions be inside the private section. ",
  StyleBox["NOTE! When redefining a function in a package it is a good rule \
to always evaluate the complete package to prevent symbols from being created \
in the wrong context.",
    FontVariations->{"Underline"->True}],
  " To make a fresh definition of the a package symbol or function, use \
Remove to delete the created symbol and definition from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". "
}], "Text"],

Cell[TextData[{
  "If the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " notebook is used to write and test the package code, problems with \
contexts may occur. The reason for this is that the notebook parser sets the \
context for all symbols in an input cell before evaluating if the input cell \
contains a single expression. This means that if"
}], "Text"],

Cell["Begin[\"foo`\"]; fee", "Input"],

Cell["\<\
is evaluated then the context for symbol fee will not be changed. The \
solution to this is to separate all Begin, End, BeginPackage, and EndPackage \
in separate cells.\
\>", "Text"],

Cell["\<\
There is one exception from the concept of packages, for functions defined \
\"directly\" into the default context \"Global`\". In this case all symbols \
used will be put into the same context. All definitions made in the \"Global\
\.b4\" context can be compiled to the \"Global\" package by using \
CompilePackage[\"Global`\"].\
\>", "Text"],

Cell[TextData[{
  "Installing the compiled executables by using InstallCode, will store the \
",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " version of the functions into the container SourceDownValues. This \
container will not change if the functions are redefined in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " while the corresponding executable is installed. When using UninstallCode \
to uninstall the executable, all the functions in the package will be \
restored to the definitions they had before InstallCode was used. All changes \
in these definitions during the period when the executable was installed, are \
deleted from ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". However, the internal MathCode tables are not affected, which leads to \
discrepancies between the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " definitions and definitions stored by MathCode. The following rule is \
therefore recommended:"
}], "Text"],

Cell["Do UninstallCode[] before redefining the source.", "Text",
  TextAlignment->Center,
  TextJustification->0,
  FontWeight->"Bold"]
}, Open  ]]
},
FrontEndVersion->"5.2 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 949}},
WindowToolbars->{},
WindowSize->{1272, 922},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{597.563, 842.375},
"PaperOrientation"->"Portrait",
"Magnification"->1},
Magnification->1,
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Style Definitions", "Subtitle"],
  
  Cell["\<\
Modify the definitions below to change the default appearance of \
all cells in a given style.  Make modifications to any definition using \
commands in the Format menu.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Working"],
    PageWidth->WindowWidth,
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    PageWidth->WindowWidth,
    ScriptMinSize->12,
    FontSize->16],
  
  Cell[StyleData[All, "Condensed"],
    PageWidth->WindowWidth,
    CellBracketOptions->{"Margins"->{1, 1},
    "Widths"->{0, 5}},
    ScriptMinSize->8,
    FontSize->11],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    ScriptMinSize->7,
    FontSize->10,
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
The options defined for the style below will be used at the \
Notebook level.\
\>", "Text"],
  
  Cell[StyleData["Notebook"],
    PageHeaders->{{Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
            TextData[ {
              ValueBox[ "FileName"]}], "Header"], None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"]}},
    PageHeaderLines->{True, True},
    PrintingOptions->{"FirstPageHeader"->False,
    "FacingPages"->True},
    CellFrameLabelMargins->6,
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headings", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    ShowCellBracket->False,
    CellMargins->{{0, 0}, {0, 0}},
    PageBreakBelow->False,
    LineSpacing->{1, 0},
    CounterIncrements->"Title",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subtitle", 0}, {"Subsubtitle", 0}},
    FontSize->34,
    FontColor->GrayLevel[1],
    Background->RGBColor[0, 0, 1]],
  
  Cell[StyleData["Title", "Presentation"],
    CellMargins->{{0, 0}, {0, 0}},
    LineSpacing->{1, 0},
    FontSize->44],
  
  Cell[StyleData["Title", "Condensed"],
    CellMargins->{{0, 0}, {0, 0}},
    FontSize->20],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{0, 0}, {0, 0}},
    FontSize->24,
    FontTracking->"Plain",
    Background->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    ShowCellBracket->False,
    CellMargins->{{0, 0}, {0, 0}},
    PageBreakBelow->False,
    LineSpacing->{1, 3},
    ParagraphIndent->-96,
    CounterIncrements->"Subtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}, {
        "Subsubtitle", 0}},
    FontFamily->"Helvetica",
    FontSize->18,
    FontColor->GrayLevel[1],
    Background->RGBColor[0.2, 0.700008, 0.700008]],
  
  Cell[StyleData["Subtitle", "Presentation"],
    CellMargins->{{0, 0}, {0, 0}},
    LineSpacing->{1, 6},
    ParagraphIndent->-157,
    FontSize->30],
  
  Cell[StyleData["Subtitle", "Condensed"],
    CellMargins->{{0, 0}, {0, 0}},
    ParagraphIndent->-78,
    FontSize->14],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{0, 0}, {0, 0}},
    ParagraphIndent->-85,
    FontSize->16,
    Background->GrayLevel[0.6]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubtitle"],
    ShowCellBracket->False,
    CellMargins->{{10, 4}, {30, 10}},
    PageBreakBelow->False,
    CounterIncrements->"Subsubtitle",
    CounterAssignments->{{"Section", 0}, {"Equation", 0}, {"Figure", 0}},
    FontFamily->"Helvetica",
    FontSize->14,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subsubtitle", "Presentation"],
    CellMargins->{{8, 10}, {40, 20}},
    LineSpacing->{1, 0},
    FontSize->24],
  
  Cell[StyleData["Subsubtitle", "Condensed"],
    CellMargins->{{8, 10}, {12, 8}},
    FontSize->12],
  
  Cell[StyleData["Subsubtitle", "Printout"],
    CellMargins->{{9, 10}, {50, 10}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellFrame->{{6, 0}, {0, 1}},
    CellDingbat->None,
    CellMargins->{{12, Inherited}, {4, 24}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameMargins->6,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["Section", "Presentation"],
    CellMargins->{{10, 10}, {8, 32}},
    LineSpacing->{1, 2},
    FontSize->24,
    FontTracking->"Condensed"],
  
  Cell[StyleData["Section", "Condensed"],
    CellMargins->{{8, Inherited}, {2, 12}},
    FontSize->12],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{9, 0}, {2, 50}},
    FontSize->14,
    FontTracking->"Plain",
    FontColor->GrayLevel[0]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellMargins->{{12, Inherited}, {8, 20}},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->13,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsection", "Presentation"],
    CellMargins->{{11, 10}, {8, 32}},
    LineSpacing->{1, 0},
    FontSize->22],
  
  Cell[StyleData["Subsection", "Condensed"],
    CellMargins->{{8, Inherited}, {2, 12}},
    FontSize->12],
  
  Cell[StyleData["Subsection", "Printout"],
    CellMargins->{{9, 0}, {4, 40}},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellDingbat->"\[FilledSquare]",
    CellMargins->{{25, Inherited}, {8, 12}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    CounterIncrements->"Subsubsection",
    FontFamily->"Times",
    FontSize->13,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsubsection", "Presentation"],
    CellMargins->{{29, 10}, {8, 26}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Subsubsection", "Condensed"],
    CellMargins->{{22, Inherited}, {2, 12}},
    FontSize->10],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellMargins->{{21, 0}, {4, 20}},
    FontSize->11]
  }, Open  ]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Body Text", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{12, 10}, {5, 5}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 12},
    CounterIncrements->"Text",
    FontFamily->"Times"],
  
  Cell[StyleData["Text", "Presentation"],
    CellMargins->{{13, 10}, {8, 8}},
    LineSpacing->{1, 5},
    ParagraphSpacing->{0, 12}],
  
  Cell[StyleData["Text", "Condensed"],
    CellMargins->{{8, 10}, {4, 4}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 4}],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{9, 0}, {4, 4}},
    ParagraphSpacing->{0, 6}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SmallText"],
    CellMargins->{{12, 10}, {5, 5}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 6},
    CounterIncrements->"SmallText",
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["SmallText", "Presentation"],
    CellMargins->{{13, 10}, {8, 8}},
    LineSpacing->{1, 5},
    FontSize->12],
  
  Cell[StyleData["SmallText", "Condensed"],
    CellMargins->{{8, 10}, {2, 2}},
    LineSpacing->{1, 2},
    FontSize->9],
  
  Cell[StyleData["SmallText", "Printout"],
    CellMargins->{{9, 0}, {4, 4}},
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Input/Output", "Section"],
  
  Cell["\<\
The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{52, 10}, {8, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelMargins->{{5, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    CounterIncrements->"Input",
    FontWeight->"Bold",
    Background->RGBColor[1, 1, 0]],
  
  Cell[StyleData["Input", "Presentation"],
    CellMargins->{{62, Inherited}, {10, 10}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Input", "Condensed"],
    CellMargins->{{40, 10}, {4, 4}}],
  
  Cell[StyleData["Input", "Printout"],
    CellMargins->{{44, 0}, {6, 6}},
    Background->GrayLevel[0.8]]
  }, Closed]],
  
  Cell[StyleData["InlineInput"],
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    DefaultFormatType->DefaultInputFormatType,
    AutoItalicWords->{},
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    CounterIncrements->"Input",
    FontWeight->"Bold"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{52, 10}, {8, 8}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    CellLabelMargins->{{3, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Output",
    Background->RGBColor[1, 0.900008, 0.900008]],
  
  Cell[StyleData["Output", "Presentation"],
    CellMargins->{{62, Inherited}, {12, 5}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Output", "Condensed"],
    CellMargins->{{40, Inherited}, {4, 1}}],
  
  Cell[StyleData["Output", "Printout"],
    CellMargins->{{44, 0}, {6, 2}},
    Background->GrayLevel[0.900008]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    CellMargins->{{62, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontColor->RGBColor[1, 0, 0]],
  
  Cell[StyleData["Message", "Presentation"],
    CellMargins->{{74, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Message", "Condensed"],
    CellMargins->{{50, Inherited}, {Inherited, Inherited}}],
  
  Cell[StyleData["Message", "Printout"],
    CellMargins->{{54, Inherited}, {Inherited, Inherited}},
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    CellMargins->{{62, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Print",
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Presentation"],
    CellMargins->{{74, Inherited}, {Inherited, Inherited}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Print", "Condensed"],
    CellMargins->{{50, Inherited}, {Inherited, Inherited}}],
  
  Cell[StyleData["Print", "Printout"],
    CellMargins->{{54, Inherited}, {Inherited, Inherited}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    CellMargins->{{62, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->DefaultOutputFormatType,
    FormatType->InputForm,
    CounterIncrements->"Graphics",
    StyleMenuListing->None],
  
  Cell[StyleData["Graphics", "Presentation"],
    CellMargins->{{74, Inherited}, {Inherited, Inherited}}],
  
  Cell[StyleData["Graphics", "Condensed"],
    CellMargins->{{52, Inherited}, {Inherited, Inherited}},
    ImageSize->{175, 175}],
  
  Cell[StyleData["Graphics", "Printout"],
    CellMargins->{{54, Inherited}, {Inherited, Inherited}},
    ImageSize->{250, 250}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->11,
    FontWeight->"Bold",
    FontColor->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["CellLabel", "Presentation"],
    FontSize->12],
  
  Cell[StyleData["CellLabel", "Condensed"],
    FontSize->8],
  
  Cell[StyleData["CellLabel", "Printout"],
    FontSize->8,
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Unique Styles", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Author"],
    ShowCellBracket->False,
    CellMargins->{{10, 4}, {2, 10}},
    FontSize->16,
    FontSlant->"Italic"],
  
  Cell[StyleData["Author", "Presentation"],
    CellMargins->{{12, 10}, {2, 12}},
    LineSpacing->{1, 5},
    ParagraphSpacing->{0, 12},
    FontSize->20],
  
  Cell[StyleData["Author", "Condensed"],
    CellMargins->{{8, 10}, {1, 4}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 4},
    FontSize->12],
  
  Cell[StyleData["Author", "Printout"],
    CellMargins->{{9, 0}, {4, 12}},
    ParagraphSpacing->{0, 6},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Copyright"],
    ShowCellBracket->False,
    CellMargins->{{10, 10}, {40, 2}},
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["Copyright", "Presentation"],
    CellMargins->{{12, 10}, {50, 2}},
    LineSpacing->{1, 5},
    FontSize->12],
  
  Cell[StyleData["Copyright", "Condensed"],
    CellMargins->{{8, 10}, {12, 1}},
    LineSpacing->{1, 2},
    FontSize->9],
  
  Cell[StyleData["Copyright", "Printout"],
    CellMargins->{{9, 0}, {72, 4}},
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Example"],
    CellMargins->{{12, 10}, {5, 12}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 12},
    CounterIncrements->"Example",
    FontFamily->"Times",
    FontWeight->"Bold"],
  
  Cell[StyleData["Example", "Presentation"],
    CellMargins->{{18, 10}, {8, 20}},
    LineSpacing->{1, 5},
    ParagraphSpacing->{0, 12}],
  
  Cell[StyleData["Example", "Condensed"],
    CellMargins->{{8, 10}, {4, 8}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 4}],
  
  Cell[StyleData["Example", "Printout"],
    CellMargins->{{9, 0}, {4, 10}},
    ParagraphSpacing->{0, 6}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Definition"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{52, 10}, {8, 8}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
    ShowStringCharacters->True,
    CounterIncrements->"Definition",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.2, 0.700008, 0.700008]],
  
  Cell[StyleData["Definition", "Presentation"],
    CellMargins->{{62, Inherited}, {5, 12}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Definition", "Condensed"],
    CellMargins->{{40, 10}, {1, 4}}],
  
  Cell[StyleData["Definition", "Printout"],
    CellMargins->{{44, 0}, {2, 6}},
    Background->GrayLevel[0.6]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Theorem"],
    CellFrame->{{3, 0}, {0, 0}},
    CellMargins->{{52, 10}, {8, 8}},
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
    ShowStringCharacters->True,
    CounterIncrements->"Theorem",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontColor->GrayLevel[1],
    Background->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["Theorem", "Presentation"],
    CellMargins->{{62, Inherited}, {5, 12}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["Theorem", "Condensed"],
    CellMargins->{{40, 10}, {1, 4}}],
  
  Cell[StyleData["Theorem", "Printout"],
    CellMargins->{{44, 0}, {2, 6}},
    Background->GrayLevel[0.4]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExerciseMain"],
    CellFrame->{{6, 0}, {0, 1}},
    CellMargins->{{12, Inherited}, {4, 20}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    CellFrameColor->RGBColor[0.571389, 0.19675, 0.570504],
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}},
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold",
    FontColor->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["ExerciseMain", "Presentation"],
    CellMargins->{{18, 10}, {8, 32}},
    LineSpacing->{1, 2},
    FontSize->24,
    FontTracking->"Condensed"],
  
  Cell[StyleData["ExerciseMain", "Condensed"],
    CellMargins->{{8, Inherited}, {2, 12}},
    FontSize->12],
  
  Cell[StyleData["ExerciseMain", "Printout"],
    CellMargins->{{9, 0}, {2, 50}},
    CellFrameColor->GrayLevel[0.500008],
    FontSize->14,
    FontTracking->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Exercise"],
    CellDingbat->"\[FilledDownTriangle]",
    CellMargins->{{23, Inherited}, {4, 18}},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    CounterIncrements->"Subsubsection",
    FontFamily->"Times",
    FontSize->13,
    FontWeight->"Bold",
    FontColor->RGBColor[0.571389, 0.19675, 0.570504]],
  
  Cell[StyleData["Exercise", "Presentation"],
    CellMargins->{{33, 10}, {8, 26}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Exercise", "Condensed"],
    CellMargins->{{17, Inherited}, {2, 12}},
    FontSize->10],
  
  Cell[StyleData["Exercise", "Printout"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellDingbat->None,
    CellMargins->{{9, 0}, {6, 20}},
    FontSize->11,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ExerciseText"],
    CellMargins->{{62, 10}, {5, 5}},
    LineSpacing->{1, 3},
    ParagraphSpacing->{0, 8},
    CounterIncrements->"ExcersiceText",
    FontFamily->"Times"],
  
  Cell[StyleData["ExerciseText", "Presentation"],
    CellMargins->{{74, 10}, {8, 8}},
    LineSpacing->{1, 5},
    ParagraphSpacing->{0, 12}],
  
  Cell[StyleData["ExerciseText", "Condensed"],
    CellMargins->{{52, 10}, {2, 2}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0, 4}],
  
  Cell[StyleData["ExerciseText", "Printout"],
    CellMargins->{{54, 0}, {4, 4}},
    ParagraphSpacing->{0, 6}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Itemize"],
    CellDingbat->"\[FilledSmallCircle]",
    CellMargins->{{65, Inherited}, {8, 8}},
    FontFamily->"Times",
    FontSize->13,
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontVariations->{"Underline"->False,
    "Outline"->False,
    "Shadow"->False}],
  
  Cell[StyleData["Itemize", "Presentation"],
    CellMargins->{{Inherited, 10}, {8, 12}},
    LineSpacing->{1, 0},
    FontSize->18],
  
  Cell[StyleData["Itemize", "Condensed"],
    CellMargins->{{Inherited, Inherited}, {2, 12}},
    FontSize->10],
  
  Cell[StyleData["Itemize", "Printout"],
    CellMargins->{{Inherited, 0}, {4, 20}},
    FontSize->11]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayCode"],
    CellFrame->2,
    CellMargins->{{52, 10}, {8, 8}},
    CellHorizontalScrolling->True,
    PageBreakWithin->True,
    CellLabelMargins->{{5, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->DefaultInputFormatType,
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    FontWeight->"Bold",
    Background->RGBColor[1, 1, 0]],
  
  Cell[StyleData["DisplayCode", "Presentation"],
    CellMargins->{{62, Inherited}, {10, 10}},
    LineSpacing->{1, 0}],
  
  Cell[StyleData["DisplayCode", "Condensed"],
    CellMargins->{{40, 10}, {4, 4}}],
  
  Cell[StyleData["DisplayCode", "Printout"],
    CellMargins->{{44, 0}, {6, 6}},
    Background->GrayLevel[0.8]]
  }, Closed]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Formulas and Programming", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DisplayFormula"],
    CellMargins->{{62, 10}, {2, 10}},
    CellHorizontalScrolling->True,
    ScriptLevel->0,
    SingleLetterItalics->True,
    UnderoverscriptBoxOptions->{LimitsPositioning->True}],
  
  Cell[StyleData["DisplayFormula", "Presentation"],
    CellMargins->{{74, 10}, {2, 10}},
    FontSize->18],
  
  Cell[StyleData["DisplayFormula", "Condensed"],
    CellMargins->{{52, 10}, {2, 10}},
    FontSize->10],
  
  Cell[StyleData["DisplayFormula", "Printout"],
    CellMargins->{{54, 10}, {2, 10}},
    FontSize->10]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ChemicalFormula"],
    CellMargins->{{62, 10}, {2, 10}},
    AutoSpacing->False,
    ScriptLevel->1,
    ScriptBaselineShifts->{0.6, Automatic},
    SingleLetterItalics->False,
    ZeroWidthTimes->True],
  
  Cell[StyleData["ChemicalFormula", "Presentation"],
    CellMargins->{{74, 10}, {2, 10}},
    FontSize->10],
  
  Cell[StyleData["ChemicalFormula", "Condensed"],
    CellMargins->{{52, 10}, {2, 10}},
    FontSize->10],
  
  Cell[StyleData["ChemicalFormula", "Printout"],
    CellMargins->{{54, 10}, {2, 10}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellMargins->{{12, 10}, {Inherited, 6}},
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "Presentation"],
    CellMargins->{{13, 30}, {Inherited, 4}},
    FontSize->9.5],
  
  Cell[StyleData["Program", "Condensed"],
    CellMargins->{{8, 10}, {Inherited, 4}},
    FontSize->9.5],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{9, 0}, {Inherited, 4}},
    FontSize->9.5]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Automatic Numbering", "Section"],
  
  Cell["\<\
The following styles are useful for numbered equations, figures, \
etc.  They automatically give the cell a FrameLabel containing a reference to \
a particular counter, and also increment that counter.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedEquation"],
    CellMargins->{{62, 10}, {Inherited, Inherited}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "NumberedEquation"], ")"}]]}, {None, None}},
    DefaultFormatType->DefaultInputFormatType,
    CounterIncrements->"NumberedEquation",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedEquation", "Presentation"],
    CellMargins->{{74, 10}, {Inherited, Inherited}}],
  
  Cell[StyleData["NumberedEquation", "Condensed"],
    CellMargins->{{52, 10}, {Inherited, Inherited}}],
  
  Cell[StyleData["NumberedEquation", "Printout"],
    CellMargins->{{54, 0}, {Inherited, Inherited}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedFigure"],
    CellMargins->{{62, 145}, {Inherited, Inherited}},
    CellFrameLabels->{{None, None}, {Cell[ 
            TextData[ {"Figure ", 
              CounterBox[ "NumberedFigure"]}]], None}},
    CounterIncrements->"NumberedFigure",
    ImageMargins->{{43, Inherited}, {Inherited, 0}},
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedFigure", "Presentation"]],
  
  Cell[StyleData["NumberedFigure", "Condensed"]],
  
  Cell[StyleData["NumberedFigure", "Printout"]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NumberedTable"],
    CellMargins->{{62, 145}, {Inherited, Inherited}},
    CellFrameLabels->{{None, None}, {Cell[ 
            TextData[ {"Table ", 
              CounterBox[ "NumberedTable"]}]], None}},
    TextAlignment->Center,
    CounterIncrements->"NumberedTable",
    FormatTypeAutoConvert->False],
  
  Cell[StyleData["NumberedTable", "Presentation"]],
  
  Cell[StyleData["NumberedTable", "Condensed"]],
  
  Cell[StyleData["NumberedTable", "Printout"]]
  }, Open  ]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Styles for Headers and Footers", "Section"],
  
  Cell[StyleData["Header"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontSlant->"Italic"],
  
  Cell[StyleData["Footer"],
    CellMargins->{{0, 0}, {0, 4}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->6],
  
  Cell[StyleData["PageNumber"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontWeight->"Bold"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlink Styles", "Section"],
  
  Cell["\<\
The cells below define styles useful for making hypertext \
ButtonBoxes.  The \"Hyperlink\" style is for links within the same Notebook, \
or between Notebooks.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->RGBColor[0, 0, 1],
    Background->None,
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonFrame->"None",
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Presentation"]],
  
  Cell[StyleData["Hyperlink", "Condensed"]],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Open  ]],
  
  Cell["\<\
The following styles are for linking automatically to the on-line \
help system.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MainBookLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "MainBook", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["MainBookLink", "Presentation"]],
  
  Cell[StyleData["MainBookLink", "Condensed"]],
  
  Cell[StyleData["MainBookLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AddOnsLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "AddOns", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["AddOnsLink", "Presentation"]],
  
  Cell[StyleData["AddOnsLink", "Condensed"]],
  
  Cell[StyleData["AddOnLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontFamily->"Courier",
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "RefGuideLink", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefGuideLink", "Presentation"]],
  
  Cell[StyleData["RefGuideLink", "Condensed"]],
  
  Cell[StyleData["RefGuideLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GettingStartedLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "GettingStarted", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["GettingStartedLink", "Presentation"]],
  
  Cell[StyleData["GettingStartedLink", "Condensed"]],
  
  Cell[StyleData["GettingStartedLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OtherInformationLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    FontColor->GrayLevel[1],
    Background->RGBColor[1, 0.4, 0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "OtherInformation", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["OtherInformationLink", "Presentation"]],
  
  Cell[StyleData["OtherInformationLink", "Condensed"]],
  
  Cell[StyleData["OtherInformationLink", "Printout"],
    FontColor->GrayLevel[0],
    Background->GrayLevel[1]]
  }, Closed]]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 43, 0, 55, "Title"],
Cell[1800, 53, 31, 0, 41, "Subtitle"],
Cell[1834, 55, 36, 0, 58, "Subsubtitle"],
Cell[1873, 57, 484, 10, 91, "Text"],

Cell[CellGroupData[{
Cell[2382, 71, 46, 0, 56, "Section"],
Cell[2431, 73, 51, 0, 29, "Text"],
Cell[2485, 75, 140, 1, 33, "Itemize"],
Cell[2628, 78, 209, 5, 33, "Itemize"],
Cell[2840, 85, 628, 17, 34, "Itemize"],
Cell[3471, 104, 91, 1, 33, "Itemize"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3599, 110, 48, 0, 56, "Section"],
Cell[3650, 112, 104, 3, 29, "Text"],
Cell[3757, 117, 70, 0, 33, "Itemize"],
Cell[3830, 119, 96, 1, 33, "Itemize"],
Cell[3929, 122, 67, 0, 33, "Itemize"],
Cell[3999, 124, 63, 0, 33, "Itemize"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4099, 129, 110, 4, 56, "Section"],

Cell[CellGroupData[{
Cell[4234, 137, 120, 4, 46, "Subsection"],
Cell[4357, 143, 447, 13, 60, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4841, 161, 52, 0, 46, "Subsection"],
Cell[4896, 163, 1126, 24, 99, "Text"],
Cell[6025, 189, 215, 4, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6277, 198, 48, 0, 46, "Subsection"],
Cell[6328, 200, 260, 7, 30, "Text"],
Cell[6591, 209, 65, 1, 50, "Input"],
Cell[6659, 212, 133, 4, 30, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[6841, 222, 37, 0, 56, "Section"],

Cell[CellGroupData[{
Cell[6903, 226, 47, 0, 46, "Subsection"],
Cell[6953, 228, 289, 7, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7279, 240, 48, 0, 46, "Subsection"],
Cell[7330, 242, 404, 12, 30, "Text"],
Cell[7737, 256, 254, 5, 30, "Text"],
Cell[7994, 263, 317, 8, 30, "Text"],
Cell[8314, 273, 87, 1, 50, "Input"],
Cell[8404, 276, 232, 5, 60, "Text"],
Cell[8639, 283, 84, 1, 50, "Input"],
Cell[8726, 286, 675, 23, 60, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9438, 314, 86, 3, 64, "Subsection"],
Cell[9527, 319, 328, 5, 48, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9892, 329, 123, 5, 46, "Subsection"],
Cell[10018, 336, 557, 16, 48, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[10624, 358, 75, 0, 56, "Section"],

Cell[CellGroupData[{
Cell[10724, 362, 36, 0, 46, "Subsection"],
Cell[10763, 364, 175, 4, 30, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10975, 373, 71, 0, 46, "Subsection"],
Cell[11049, 375, 402, 9, 48, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11488, 389, 29, 0, 46, "Subsection"],
Cell[11520, 391, 144, 3, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11701, 399, 38, 0, 46, "Subsection"],
Cell[11742, 401, 513, 14, 60, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12292, 420, 41, 0, 46, "Subsection"],
Cell[12336, 422, 425, 11, 48, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12798, 438, 60, 0, 46, "Subsection"],
Cell[12861, 440, 370, 9, 91, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13268, 454, 28, 0, 46, "Subsection"],
Cell[13299, 456, 319, 4, 48, "Text"],
Cell[13621, 462, 119, 2, 110, "Input"],
Cell[13743, 466, 31, 0, 29, "Text"],
Cell[13777, 468, 135, 3, 110, "Input"],
Cell[13915, 473, 78, 0, 29, "Text"],
Cell[13996, 475, 132, 2, 130, "Input"],
Cell[14131, 479, 73, 0, 29, "Text"],
Cell[14207, 481, 152, 3, 130, "Input"],
Cell[14362, 486, 147, 2, 29, "Text"],
Cell[14512, 490, 130, 2, 110, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[14679, 497, 27, 0, 46, "Subsection"],
Cell[14709, 499, 430, 9, 48, "Text"],
Cell[15142, 510, 113, 2, 29, "Text"],
Cell[15258, 514, 88, 1, 50, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15383, 520, 28, 0, 46, "Subsection"],
Cell[15414, 522, 118, 3, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15569, 530, 63, 0, 46, "Subsection"],

Cell[CellGroupData[{
Cell[15657, 534, 39, 0, 37, "Subsubsection"],
Cell[15699, 536, 72, 0, 29, "Text"],
Cell[15774, 538, 62, 1, 50, "Input"],
Cell[15839, 541, 117, 5, 29, "Text"],
Cell[15959, 548, 128, 3, 29, "Text"]
}, Open  ]],

Cell[CellGroupData[{
Cell[16124, 556, 30, 0, 37, "Subsubsection"],
Cell[16157, 558, 165, 2, 29, "Text"],
Cell[16325, 562, 62, 1, 50, "Input"],
Cell[16390, 565, 249, 7, 29, "Text"],
Cell[16642, 574, 118, 2, 110, "Input"],
Cell[16763, 578, 292, 9, 29, "Text"],
Cell[17058, 589, 64, 1, 29, "Text"],
Cell[17125, 592, 406, 11, 29, "Text"],
Cell[17534, 605, 54, 0, 29, "Text"],
Cell[17591, 607, 65, 1, 50, "Input"],
Cell[17659, 610, 27, 0, 29, "Text"],
Cell[17689, 612, 41, 1, 50, "Input"],
Cell[17733, 615, 184, 8, 29, "Text"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[17966, 629, 30, 0, 46, "Subsection"],

Cell[CellGroupData[{
Cell[18021, 633, 53, 0, 37, "Subsubsection"],
Cell[18077, 635, 154, 3, 29, "Text"],

Cell[CellGroupData[{
Cell[18256, 642, 86, 1, 50, "Input"],
Cell[18345, 645, 46, 1, 49, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18428, 651, 49, 1, 50, "Input"],
Cell[18480, 654, 40, 1, 49, "Output"]
}, Open  ]],
Cell[18535, 658, 734, 21, 48, "Text"],
Cell[19272, 681, 320, 7, 29, "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[19653, 695, 41, 0, 56, "Section"],
Cell[19697, 697, 386, 8, 48, "Text"],
Cell[20086, 707, 816, 17, 67, "Text"],
Cell[20905, 726, 373, 8, 48, "Text"],
Cell[21281, 736, 37, 0, 50, "Input"],
Cell[21321, 738, 193, 4, 29, "Text"],
Cell[21517, 744, 353, 6, 48, "Text"],
Cell[21873, 752, 987, 22, 67, "Text"],
Cell[22863, 776, 135, 3, 29, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

